March 2012 update 0.11.1
-------------------------------------------------

This is a stability improvement release and we suggest to use it instead 0.11

Bug fixes

 avoid unecessary I/O - cache contents of timestamp/{header,footer}_include until reconfiguration occures
 avoid eftar file test and exception on every page access
 fix clean button
 various OpenGrok script fixes (JAVA_OPTS now configurable, can now disable sending config to webapp, 
 Bug #19181: - ignored list should not contain bin,lib entries
 Bug #19188: if filename has ":" in its name, the link to it from xref will be wrong
 Bug #19184: - README file contents are not displayed anymore in directory listing


February 2012 update 0.11
-------------------------------------------------

This is a major update. It is advised that you cleanup your old DATA_ROOT
(ideally remove it, or move it aside) and run indexing from fresh. Also the web
application should be replaced, since the new indexes are not compatible with
the old web application. Note that this doesn't apply to upgrades from the 0.11
release candidate, since the format of the xrefs didn't change between the
release candidate and the release. 

New features

    PHP analyzer
    Visual Basic analyzer
    Javascript analyzer
    C# analyzer
    completely refactored UI, upgraded jquery to 1.4.4
    SSL, SSO and mod_proxy compatible

Bug fixes

    Bug #17612: Simple PHP Analyzer
    Bug #17507: indexer hangs when svn requests certificate confirmation
    Bug #17609: path assumptions & binary names used by installer script need modifications.
    Bug #17688: File handles leaked in JSPs
    Bug #13677: xref cache is not updated if code changes in SRC_ROOT
    Bug #17731: Character encoding improper in Annotation
    Bug #17817: xref treats include statements with angle brackets and quote marks differently when they contain path part
    Bug #17816: Link to include file without file extension performs definition search
    Bug #17936: ArrayIndexOutOfBoundsException when using n=50 as URL query parameter
    Bug #18163: C++ keywords is not recognized in xref output
    Bug #18198: ShXref gets confused by here-documents
    Bug #17885: /**/ comments broke java xref
    Bug #17584: Beginning of highlighted change in code is not started from absolute zero position in the row
    Bug #18103: RFE: repository CLI cmds - better error reporting
    Bug #16895: Maven build doesn't update manifest
    Bug #18144: indexer will enter infinite cycle if it encounters symlink to dot , Add an "all" target to compile everything and run test cases, pmd, findbugs etc
    Bug #16894: Maven build lacks info.properties
    Bug #18585: Exceptions are not logged if severity is higher than CONFIG
    Bug #18586: ArrayIndexOutOfBoundsException when indexing SQL file
    Bug #18606: URL suffix for user information not included in history view
    Bug #18602: JarAnalyzer can run out of memory
    Bug #18641: Cannot access history for directories
    Bug #18932: non escaped backslash in output javascript causes issues * Implement the verbatim string support for C# (Bug 18655) to suffixes in the xml analyzer class. (Bug 18687).
    Bug #18754: opensearch does not work with HTTPS fixing as per Jens Elkner
    Bug #19116: SQLIntegrityConstraintViolationException when indexing Bazaar history
    Bug #1720: Add service outage banner at top of webapp pages
    Bug #19105: convert the link to parent directory to .. and move it to the file listing
    Bug #19105: use the browser's default fonts update the DirectoryListing test after fix for Bug 19105 and use getParentFile() for better portability
    Bug #19105: reuse the SimpleDateFormat instance
    Bug #19145: annotate view for Mercurial displays only first name of the author in some cases
    Bug #19141: opensearch based searches are broken in mod_proxy environment
    Bug #19161: Solaris package should not deliver source.war to /var/tomcat6 in any form
    Bug #19110: Tab expansion problems in 0.11-rctemp - disable of default tabs to mitigate

For bug details refer to Bugzilla -
https://defect.opensolaris.org/bz/buglist.cgi?product=opengrok&query_format=advanced&target_milestone=0.11&order=bug_id%20DESC

Contributors

We'd like to thank all the people who report bugs, send us ideas for
improvements or contribute code. Below are just the people who sent patches or
pushed code, but that doesn't mean that we don't appreciate your work. Reports
and feedback from the users of OpenGrok is essential to make the developers able
to continue improving the product. Note that this is just a summary of how many
changes each person made, which doesn't necessarily reflect how significant each
change was. Inspect the history log with hg log -v -r 0.10:0.11 to get all
details.

56 Knut Anders Hatlen <knut.hatlen@oracle.com>
56 Trond Norbye <trond.norbye@gmail.com>
24 Vladimir Kotal <Vladimir.Kotal@oracle.com>
15 Jens Elkner <jel+opengrok@cs.uni-magdeburg.de>
12 Lubos Kosco <Lubos.Kosco@Oracle.COM>
1 Chris Eldredge <chris.eldredge@gmail.com>
1 Felix Annan <felannan@yahoo.com>
1 Haufe-Lexware - Christoph Hofmann <Christoph.Hofmann@haufe-lexware.com>
1 Karthik Rajagopalan <Karthik.Rajagopalan@schrodinger.com>
1 Miroslav Osladil <mira@osladil.cz>


January 2011 update 0.10
-------------------------------------------------

This is a major update. It is advised that you cleanup your old
DATA_ROOT and run indexing from fresh. Also the web application should
be replaced, since the new indexes are not compatible with the old web
application.

New features:

* python analyzer, perl analyzer
* listing of variables/methods for quicker navigation
* sh analyzer xrefs improved
* SQL analyzer updated to SQL:2008
* UI usability improvements
* updated Lucene to 3.0.2
* introduced Maven as alternative build system to Ant

Bugs fixed:

Bug #5590: Unhighlighted difference in compare list
Bug #11264: Add a python specific language analyzer.
Bug #13184: provide quick links to annotate,history and download from search results view: diff link for history search
Bug #13184: provide quick links to annotate,history and download from search results view
Bug #13777: Indexer should print "Adding: ..." before it adds a file
Bug #14545: clicking on annotate doesn't preserve line number
Bug #14663: broken syntax highlight in ksh script when ` is used (and when " is escaped)
Bug #14924: Java method calls incorrectly classified as definitions
Bug #15468: Log useful info from indexer regardless of -v
Bug #15661: OpenGrok should support new ksh command substitution x=${ cmd ; }
Bug #15890: Missing anchor in xref
Bug #15938: Analyzers should only use JFlex's public API
Bug #15947: Detect GNU CSSC in addition to SCCS
Bug #15948: Fail if svnadmin is missing: tests depend on it
Bug #15954: teamware repository not detected anymore
Bug #15956: indexer fails on indexing
Bug #15961: Allow certain symlinks to be followed to help with using clearcase dynamic views
bug #15961: and to files in other directories in the same project.
Bug #16006: Indexer's -P option removes customization of existing projects
Bug #16070: our ctags parser fails to parse a c signature
Bug #16076: problem of ELFAnalyzer in opengrok 0.9
Bug #16334: Indexer hangs when files contain 0x1A characters
Bug #16370: build.xml: Check for JFlex.jar and taskdef for jflex-task use different classpath
Bug #16451: Tray app doesn't work with other protocols than jmxmp
Bug #16454: Trayapp shuts down when a window is closed
Bug #16465: SVN history of filenames containing @ cannot be retrieved
Bug #16481: NumberFormatException when opening Connection Settings the second time
Bug #16611: svn repository with svn:// protocol as urn results in NPE when reading history
Bug #16660: Perforce repositories return months 1-12, not 0-11
Bug #16677: revamp option -v
Bug #16692: Index files left open after multiple project search
Bug #16760: Generating incorrect links for C/C++ "#include" statements if extension of a header file is not on the lexer's list
Bug #16761: Perforce history reader would not use per-project clients (defined by P4CONFIG files)
Bug #16764: Perforce source annotation: the date is one month ahead, time information is not available
Bug #16772: status.jsp should be less chatty in production environments
Bug #16783: more.jsp garbles matches on lines crossing internal JFlex buffer boundary
Bug #16786: Control for User Information Provider URL (userPage)
Bug #16833: Subversion repositories disabled by default
Bug #16848: Search context is displayed in lower case
Bug #16883: ShXref should reset stack on reuse
Bug #16891: Unneeded files included in opengrok.jar
Bug #16892: Maven build includes management client source in jar
Bug #16893: Maven build includes SQLXref.lex
Bug #16909: Move JFlex generated sources to default location (Maven)
Bug #16913: OpenGrok fails to use JDBC cache if -R option is specified
Bug #16961: Definitions should have serialVersionUID
Bug #16986: Relative path for data root and source root has stopped working
Bug #17074: Home link no longer works
Bug #17127: OpenGrok leaving too many open files
Bug #17128: add more syntax highlighting styles and list all definitions/functions
Bug #17169: enable wildcard prefix search in OpenGrok script by default
Bug #17294: show progress on demand
Bug #17349: path needs to be percent encoded
Bug #17373: breadcrumb path needs to be URI encoded
Bug #17374: history links need percent encoding
Bug #17375: annotate link needs percent encoding
Bug #17376: download link needs percent encoding
Bug #17378: Please remove email obfuscation
Bug #17550: Malformed search for query with national chars
Bug #17551: Double-click on some project in project list doesn't work in Internet Explorer
Bug #17554: Empty "Navigate" window in Perl code
Bug #17582: context shown in hits doesn't show symbol type for non lowercased symbols
Bug #17631: Cookie name "OpenGrok/project" is a reserved token

For bug details refer to:
http://defect.opensolaris.org/bz/buglist.cgi?bug_status=RESOLVED&bug_status=VERIFIED&bug_status=CLOSED&target_milestone=0.10&product=opengrok

Contributors:

We'd like to thank all the people who report bugs, send us ideas for
improvements or contribute code. Below are just the people who sent
patches or pushed code, but that doesn't mean that we don't appreciate
your work. Reports and feedback from the users of OpenGrok is
essential to make the developers able to continue improving the
product. Note that this is just a summary of how many changes each
person made, which doesn't necessarily reflect how significant each
change was. Inspect the history log with "hg log -v -r 0.9:0.10" to
get all details.

 68 Knut Anders Hatlen <knut.hatlen@oracle.com>, <Knut.Hatlen@Sun.COM>
 39 Lubos Kosco <Lubos.Kosco@Sun.COM>, <Lubos.Kosco@Oracle.COM>
 10 Jorgen Austvik <jaustvik@acm.org>
  9 Trond Norbye <trond.norbye@gmail.com>
  5 Patrick Higgins <patrick.allen.higgins@gmail.com>
  3 Yuriy Vasylchenko <yuriy.av@gmail.com>
  2 Leo Davis <ldavis@fonix.com>
  1 cicicici <cicicici@gmail.com>
  1 Martin Walsh <martin.walsh@oracle.com>
  1 seadog <seadog1234567890@gmail.com>


May 2010 update 0.9
-------------------------------------------------
This is a major update. It's advised you cleanup your old DATA_ROOT and run
indexing from fresh. Also the web application should be replaced, since new
indexes are not compatible with old application.
This is also a general rule for most of OpenGrok updates. We don't really
support backwards compatibility, unless it would be a really minor update.

New Features:

* Faster Lucene engine (3.0.1) underneath - faster analyzers
* New jQuery (1.4.2) underneath - UI improvements
* Support for xrefs with Unicode characters (not indexed yet, but
  finally viewable)
* New SMF service - just pass the source root, the rest is taken care
  of by the service (Solaris/OpenSolaris only)

Bugs fixed:

Bug #437 (partial): OpenGrok should support source files with multibyte characters
Bug #3435: C functions are not considered as functions
Bug #3900: Unexpected result when clicking a symbol definition
Bug #5042: Author field empty in opengrok after a multiple changeset push
Bug #5848: trimmed diff link results in NULL pointer dereference
Bug #6641: .txx file extension should be included in the list for C++ analyzer
Bug #9407: set limit for directory traversal during search for repositories
Bug #13185: broken focus
Bug #13280: RFE: Configurable tab size for xref
Bug #13330: Wrong URL when search for camel-case identifier has only one match
Bug #13362: plainanalyzer xref writer can never end for a file with long lines
Bug #13364: regression : Jar analyzer doesn't analyze the jars it used to for 0.7
Bug #13524: Color coding in diffs is confusing
Bug #13529: listing of a file (in xref) might take a LONG time
Bug #13777: Indexer should print "Adding: ..." before it adds a file
Bug #13884: IndexOutOfBoundsException in List2TokenStream.next()
Bug #13949: Missing line numbers in xref for XML file
Bug #13951: Wrong revision in info.properties when not building from head of trunk
Bug #13952: size output not correct
Bug #13961: no quick search box shown on windows (path separator problem in project names/IDs)
Bug #13996: build.xml should provide a version info for generated src.tar.gz so we don't depend on hg
Bug #13997: main logo should take you HOME ;)
Bug #14030: Many lines with same line number (regression)
Bug #14724: Incremental update of Bazaar history broken by instability in revision numbers
Bug #14757: pressing Enter on project select list box takes you to xref instead of submit of the search form
Bug #14953: history index for CVS repos should only include default branch if CVS/Tag is set
Bug #14978: upgrade lucene to 3.0.1
Bug #15004: Improved handling of UTF Byte Order Marks
Bug #15097: make the search bar in listing stay on top of the page
Bug #15114: AnalyzerGuru:stripBOM should not use String to avoid encoding issues
Bug #15240: radio buttons in history could behave like e.g. on wikipedia
Bug #15391: Executor should log the commands executed
Bug #15394: improve IPS package and SMF for OpenSolaris
Bug #15608: Search field should not be active in file display
Bug #15609: self organizing buttons in history view are confusing
Bug #15632: Strange results when searching for dotted identifier
Bug #15636: wildcard search for definitions does not work
Bug #15637: query constructed only for AND operators
Bug #15643: Simplify CLASSPATH in ogindexd
Bug #15644: Matching lines not shown when using single-character wildcard (?)
Bug #15652: history page shows a stack trace if file doesn't have a history
Bug #15690: css browser caching breaks UI
Bug #15858: String index out of range: -8161 from Summarizer
Bug #15859: html analyzer doesn't escape forms

For bug details refer to:
http://defect.opensolaris.org/bz/buglist.cgi?bug_status=RESOLVED&bug_status=VERIFIED&bug_status=CLOSED&target_milestone=0.9&product=opengrok

Contributors:

We'd like to thank all the people who report bugs, send us ideas and
improvements. Below are just people that sent patches or pushed code.
That doesn't mean that we don't appreciate your work. On the contrary,
you are the people showing other people (who have the time to write
code) what would be good to fix when you use this software and file
bugs against it!  Note that this is just a summary of how many changes
each person made, which doesn't necessarily reflect how significant
each change was. (Inspect the history log with "hg log -v -r 0.8.1:0.9"
to get all details.)

 45 Knut Anders Hatlen <Knut.Hatlen@sun.com>
 42 Lubos Kosco <Lubos.Kosco@sun.com>
  1 Chris Eldredge <chris.eldredge@gmail.com>
  1 Vitezslav Batrla <Vitezslav.Batrla@Sun.COM>


December 2009 update 0.8.1
-------------------------------------------------
minor changes from OpenGrok 0.8. Most importantly, the 0.8.1 release fixes 
the broken Solaris packages. Also OpenGrok script is now improved and 2G of
memory is needed for it to accommodate most deployments.

November 2009 update 0.8
-------------------------------------------------
FEATURES

    * Support more source code repository backends:
          o Bazaar
          o Monotone
    * Support for more languages:
          o Fortran
          o Detect C++ keywords
          o Parse C# files with the C analyzer
    * Search through multiple projects at the same time
    * Possibility to register an opengrok search as a search
      engine(provider) in Firefox(Internet Explorer)
    * History cache stored in Java DB
    * Simplified installation & setup. Improved user interface.

BUG FIXES

    * Bug #405: Mercurial history parser may easily get out of sync
    * Bug #2243: Show date and time of the last index update
    * Bug #3401: C analyzer recognizes C++ keywords
    * Bug #3624: History cache should be stored in Java DB
    * Bug #4154: History cache should be created automatically for new
      repositories
    * Bug #4505: resource leakage of ctags processes if started from the agent
    * Bug #4580: The agent tries to create the repositories on the client side
    * Bug #5826: "remote" subversion repositories no longer detected
    * Bug #6658: rss.jsp generates ill-formed XML
    * Bug #9468: history of renamed files is lost (mercurial) - use -f only
      for files
    * Bug #10440: Skip files with no sections or empty section name string
      table
    * Bug #10442: zip analyzer fails to parse odps
    * Bug #11661: Invalid author link when revision has no author
    * Bug #11662: No author not handled by JDBCHistoryCache
    * Bug #11663: Failure when commit message exceeds ~32K
    * Bug #11664: StringIndexOutOfBoundsException in MercurialHistoryParser
    * Bug #11886: set no word limit for indexing of files (can result in out
      of memory errors!)
    * Bug #11896: indexer chokes on fifos
    * Bug #12029: Check the first 1MB of the file
    * Bug #12081: History not returned for uncached repositories when using
      JDBCHistoryCache
    * Bug #12324: history view should not contain lists of files

THE ROAD AHEAD

A tentative roadmap for OpenGrok can be found here:
http://www.opensolaris.org/os/project/opengrok/Roadmap/

As of OpenGrok 0.8 we will change the release model to the train model and
start with quarterly releases.

CONTRIBUTORS

The following people contributed to this release since 0.7.

Note that this is just a summary of how many changes each person made which
doesn't necessarily reflect how significant each change was. (inspect the
history log with "hg log -v -r 0.7:tip" to get all details)

 121 Knut Anders Hatlen <Knut.Hatlen@sun.com>
  69 Trond Norbye <trond.norbye@sun.com>
  50 Lubos Kosco <Lubos.Kosco@sun.com>
  39 Jorgen Austvik <jorgen.austvik@sun.com>
   4 Jan Berg <jan.berg@sun.com>
   4 Peter Bray <Peter.Darren.Bray@gmail.com>
   1 Scott Halstead <shaltead@bloomberg.net>

October 2008 update 0.7
-------------------------------------------------
NEW FEATURES

* Support more source code repository backends:
   o ClearCase (Magnus Lind)
   o Git (Jorgen Austvik)
   o Razor (Peter Bray)

* JMX Agent (Jan Stale Berg)

OpenGrok can now talk JMX with clients. This work is the start of a 
project to make it easier to configure OpenGrok. The first proof of 
concept is a system tray applet to show OpenGrok status.

* Use external Subversion binary instead of svn-javahl.jar (Trond)

A lot of our users had problems installing svn-javahl.jar, now we use 
the system provided svn binary.

* Logging

OpenGrok is changed to use standard java.util.logging (Jan Stale Berg, 
Trond, Lubos Kosco)

* Store history cache in compressed files to save disk space (Trond)

* Quality (Trond, Knut Anders, Lubos Kosco, Jorgen Austvik)
   - We have incorporated tools like PMD, FindBugs, CheckStyle and 
Hudson into our development process, and fixed lots and lots of 
potential bugs long before any users experience them.
   - We have started to write unit-tests, and use Emma to measure how 
good they are. In this release our unit tests cover 61% of our code 
(block coverage), for OpenGrok 0.8 we aim for 70%.

* General code and design cleanup (Peter Bray, Trond, Knut Anders, Lubos 
Kosco, Jorgen Austvik)


April 2008 update 0.6.1
-------------------------------------------------
This is a bugfix release.

Please see http://src.opensolaris.org/source/history/opengrok/trunk/ for
full history information, and for the list of contributors. The following is
just a summary.

Bug #67: Duplicate magics in the analyzers
Bug #546: IOException when viewing history for xref root in multi-project installation
Bug #785: Indexer don't use the value specified with -m
Bug #779: Add option to disable index optimization upon indexing
Bug #829: create links to account details in annotate mode
Bug #966: fails on directory names that contain a plus (+) character
Bug #989: Can't reindex a subtree
Bug #988: Make it possible to optimize the index without reindexing
Bug #1007: Add URL friendly project handling
Bug #1009: Economical mode generates suggestion database
Bug #1057: double-colon in search pattern throws an error

March 2008 update 0.6
-------------------------------------------------
Please see http://src.opensolaris.org/source/history/opengrok/trunk/ for
full history information, and for the list of contributors. The following is
just a summary.

New Features:
   Analyzer-support for Tcl/Tk
   Analyzer-support for SQL
   Support for TeamWare repositories
   Use multiple index databases

Bug fixes:
   A lot.. See http://src.opensolaris.org/source/history/opengrok/trunk/

August 2007 update 0.5
-------------------------------------------------
Please see http://cvs.opensolaris.org/source/history/opengrok/trunk/ for
full history information, and for the list of contributors. The following is
just a summary.

New Features:
   Annotate support for Subversion and Mercurial
   Use of a "history cache" for some SCM's to improve performance
   Replaced system properties with configuration that may be changed runtime
   Added support for Lisp
   Updated the Lucene search engine, and allow wildcard search
   Implemented glob'ing for IgnoredNames (-i *.bak)
   Added a meta robots directive to the page headers to stop robots
   Added support for "Projects"
   Added support for RCS
   Allow user-configurable bug patterns

Bug fixes:
   Fix problems that Tomcat reports IllegalStateException for page redirects
   Added more stack traces when errors occurs

December 2006 update 0.4
-------------------------------------------------
New Features:
   New Java Analyzer
   Experimental support for Mercurial

Bug Fixes:
   Fixed image path (alt webroot) provided by Nathan Beyer
   Improved JRCS parser provided by Gustav Gunnarsson
   Improved error handling for a corrupt web.xml in error.jsp
   Fix problem with unterminated <form> tag provided by Chris Elving
   Fix problem with how arguments are passed to an editor 
          (reported by Joachim Deguara)
   Added patch for glob'ing files provided by Ben Ravago
   Added patch for displaying CVS files not present on HEAD. 
          Provided by Chris Elving.

April 2006 update 0.3.1
-------------------------------------------------
Bug Fixes:
   Fix the webapp for custom context option
   Many changes contributed by Knut Pape
   More easy to understand usage message
   tar.bz2 was not getting processed properly
   PDF files were getting cross-referenced by mistake
   Troff - missing space in xref

February 2006 update 0.3
-------------------------------------------------
New Features:
   Support for Subversion.
   A cscope like GUI for search.
   A GUI wizard for creating or updating search index.
   New option that supports webapps with different context URLs.
   Better display of matched context
   A new CSS style sheet with offwhite theme.


December 2005 update: 0.2.1
-------------------------------------------------
New Features:
   Now runs on Microsoft Windows
   a new CSS theme (polished)
   Interim support for PHP and OpenSolaris Assembler code.
   Single distributable file to keep things simple

Bug fixes:
   Fixes a XSS security issue (reported by Wez Furlong)
   Fixes bug where some CVS revisions could not be retrived
   Fixes bug in handling CVS long histories (reported by Wez Furlong)
   Handles extra characters in CVS symbol names (reported by Wez Furlong)
   More robust EFTAR file handling (reported by Andy Tucker)
   Throws more helpful error messages
   Tomcat 4.x compatibility fixes
   Minor fixes to hypertexting code that handles strings.
   Fixed bug that ignored symlinked SRC_ROOT (reported by Michael Allen)

Compatibility Note:
   The DATA_ROOT files generated by 0.2 are compatible
   with this release. Changing the source.war parameters
   and redeploying should work.
   However to get full advantage, it is advisable to
   generate the data from scratch (i.e. remove the old
   DATA_ROOT and run the run.sh again).

Initial public release, November 2005 Version 0.2
-------------------------------------------------
